#ifndef ExcellentShadow_OBJHEADER
#define ExcellentShadow_OBJHEADER
////////////////////////////////////////////////////////////////////////////////////////////////
//
//  ExcellentShadow_ObjHeader.fxh : ExcellentShadow IuWFNge`ɕKvȊ{p[^`wb_t@C
//  ̃p[^VF[_GtFNgt@C #include Ďgp܂B
//  R[h쐬: ڂ
//  full_ES.fx蒊o: jP
//  MikuMikuShadingΉ̊eGtFNg͋ɗ͂̃t@CincludeĎgp邱Ƃ𐄏܂
//
////////////////////////////////////////////////////////////////////////////////////////////////
// p[^錾

float ExShadow_X_SHADOWPOWER = 1.0;   //ANZTeZ
float ExShadow_PMD_SHADOWPOWER = 0.2; //feZ

//XN[VhE}bv擾
shared texture2D ScreenShadowMapProcessed : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 1;
    string Format = "D3DFMT_R16F";
>;
sampler2D ExShadow_ScreenShadowMapProcessedSamp = sampler_state {
    texture = <ScreenShadowMapProcessed>;
    MinFilter = LINEAR; MagFilter = LINEAR; MipFilter = NONE;
    AddressU  = CLAMP; AddressV = CLAMP;
};

//SSAO}bv擾
shared texture2D ExShadowSSAOMapOut : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 1;
    string Format = "R16F";
>;

sampler2D ExShadow_SSAOMapSamp = sampler_state {
    texture = <ExShadowSSAOMapOut>;
    MinFilter = LINEAR; MagFilter = LINEAR; MipFilter = NONE;
    AddressU  = CLAMP; AddressV = CLAMP;
};

// XN[TCY
float2 ExShadow_ViewportSize : VIEWPORTPIXELSIZE;
static float2 ExShadow_ViewportOffset = (float2(0.5,0.5)/ExShadow_ViewportSize);

bool Exist_ExcellentShadow : CONTROLOBJECT < string name = "ExcellentShadow.x"; >;
bool Exist_ExShadowSSAO : CONTROLOBJECT < string name = "ExShadowSSAO.x"; >;
float ExShadow_ShadowRate : CONTROLOBJECT < string name = "ExcellentShadow.x"; string item = "Tr"; >;
float3 ExShadow_CameraPos1 : POSITION  < string Object = "Camera"; >;
//float es_size0 : CONTROLOBJECT < string name = "ExcellentShadow.x"; string item = "Si"; >;
float4x4 ExShadow_mat1 : CONTROLOBJECT < string name = "ExcellentShadow.x"; >;

static float3 ExShadow_move1 = float3(ExShadow_mat1._41, ExShadow_mat1._42, ExShadow_mat1._43 );
static float ExShadow_CameraDistance1 = length(ExShadow_CameraPos1 - ExShadow_move1); //JƃVhES̋

/////////////////////////////////////////////////////////////////////////////////////////

struct ExShadow_RATE {
    float SadowMapVal;   // ZtVhE̎Օ
    float SSAOMapVal;    // SSAO}bvAx
};

struct ExShadow_COLOR {
    float4 Color;        // IuWFNgF
    float4 ShadowColor;  // eF
};


// ZtVhE̎Օ߂
ExShadow_RATE ExShadow_GetSelfShadowRate(float4 PPos)
{
    ExShadow_RATE Out;

    PPos.xyz /= PPos.w;
    float2 TransScreenTex;
    TransScreenTex.x = (1.0f + PPos.x) * 0.5f;
    TransScreenTex.y = (1.0f - PPos.y) * 0.5f;
    TransScreenTex += ExShadow_ViewportOffset;
    Out.SadowMapVal = tex2D(ExShadow_ScreenShadowMapProcessedSamp, TransScreenTex).r;

    Out.SSAOMapVal = 0;

    if(Exist_ExShadowSSAO){
        Out.SSAOMapVal = tex2D(ExShadow_SSAOMapSamp , TransScreenTex).r; //Ax擾
    }

    return Out;
}

// ZtVhE̓FEeF߂
ExShadow_COLOR ExShadow_GetSelfShadowColor(ExShadow_RATE IN, float4 Color, float4 ShadowColor, bool useToon)
{
    ExShadow_COLOR Out;

    Out.ShadowColor = ShadowColor;
    if (useToon) {
        Out.ShadowColor.rgb *= (1 - (1 - ExShadow_ShadowRate) * ExShadow_PMD_SHADOWPOWER);
    }else{
        Out.ShadowColor.rgb *= (1 - (1 - ExShadow_ShadowRate) * ExShadow_X_SHADOWPOWER);
    }

    //eSSAO
    Out.ShadowColor.rgb -= ((Color.rgb - Out.ShadowColor.rgb) + 0.3) * IN.SSAOMapVal * 0.2;
    Out.ShadowColor.rgb = max(Out.ShadowColor.rgb, 0);

    //SSAO
    Out.Color = lerp(Color, Out.ShadowColor, saturate(IN.SSAOMapVal * 0.4));

    return Out;
}



#endif


