////////////////////////////////////////////////////////////////////////////////////////////////
//
//  HgOreShader v0.0.1  ₷d̃AnVF[_ł
//  (HgOreShader_SubFunc.fxh : VF[_Ŏg鋤ʂ̊֐Q)
//  쐬: jP
//
////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef HgOreShader_SubFunction
#define HgOreShader_SubFunction

////////////////////////////////////////////////////////////////////////////////////////////////
// 琳ʕɕ␳@xNg

float4x4 HgOreShader_FaceMatrix : CONTROLOBJECT < string name = "(self)"; string item = ""; >;

float3 HgOreShader_GetFlontFaceNormal(float3 WPos, float3 Normal, float FaceVDir, float FaceRateH, float FaceRateV)
{
   float3 flontNormal = -HgOreShader_FaceMatrix._31_32_33; // 琳ʕ
   float3 yNormal = HgOreShader_FaceMatrix._21_22_23;      // 
   float3 xNormal = HgOreShader_FaceMatrix._11_12_13;      // E
   float3 pt0 = HgOreShader_FaceMatrix._41_42_43;          // {[ʒu

   // {[t߂̕␳
   float len1 = dot(flontNormal, WPos - pt0);
   float len2 = dot(yNormal, WPos - pt0);
   float rate = smoothstep(0.0f, 0.9f, 1.5f*len1+len2);

   // ㉺̕␳
   float cosV = dot(xNormal, Normal);
   float sinV = sqrt(1.0f - cosV * cosV);
   float3 faceNormalV = xNormal * cosV + flontNormal * sinV;
   float3 faceNormal0 = (FaceVDir>=0.0f) ? normalize(lerp(faceNormalV, yNormal, FaceVDir)) : normalize(lerp(faceNormalV, -yNormal, -FaceVDir));
   float rateV = saturate( smoothstep(-1.0f, 0.8f, dot(faceNormal0, Normal)) * FaceRateV * rate);
   float3 faceNormal1 = normalize(lerp(Normal, faceNormal0, rateV));

   // ̕␳
   float cosH = dot(yNormal, faceNormal1);
   float sinH = sqrt(1.0f - cosH * cosH);
   float3 faceNormalH = yNormal * cosH + flontNormal * sinH;
   float rateH = saturate( smoothstep(-1.0f, 0.8f, dot(faceNormal1, faceNormalH)) * FaceRateH * rate );
   return normalize(lerp(faceNormal1, faceNormalH, rateH));
}

////////////////////////////////////////////////////////////////////////////////////////////////
// ڋԂWorldԂւ̉]s
float3x3 HgOreShader_GetTangentMatrix(float3 Normal, float3 Eye, float2 Tex)
{
   // ʏɎʑꂽڃxNg
   float2 duvdx = ddx(Tex);
   float2 duvdy = ddy(Tex);
   float2 vecTan = float2(duvdx.x, duvdy.x);
   float2 vecBin = float2(duvdx.y, duvdy.y);

   // |SʂɉXYɑΉxNg
   float3 vacPx = ddx(Eye);
   float3 vacPy = ddy(Eye);

   // ʏ̃xNg|Sʂ̌ɖ߂]s
   float2x3 invMat = float2x3(cross(vacPy, Normal), cross(Normal, vacPx));

   // ڃxNg
   float3 Tangent  = normalize( mul(vecTan, invMat) );
   float3 Binormal = normalize( mul(vecBin, invMat) );

  return float3x3(Tangent, Binormal, Normal);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// fBt[YFvZ(n[to[h)
float3 HgOreShader_GetDiffuseColor(float4 diffuse, float3 underSkin, float3 N, float3 L)
{
    float NL = dot(N, L);
    float3 Color = float3(0.0f, 0.0f, 0.0f);
    float hr = 0.5f * NL + 0.5f;
    Color.rgb += hr*hr * diffuse.rgb;
    Color.rgb += hr*hr * underSkin;

    return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// fBt[YFvZ(n[to[h,eF)
float3 HgOreShader_GetShadowDiffuseColor(float4 diffuse, float3 underSkin, float3 N, float3 L)
{
    float NL = dot(N, L);
    const float s = 0.3333f;

    float3 Color = float3(0.0f, 0.0f, 0.0f);
    if(NL < s){
       float hr = 0.5f * NL + 0.5f;
       Color.rgb += hr*hr * diffuse.rgb;
       Color.rgb += hr*hr * underSkin;
    }else{
       float hr = 0.5f * (0.2f*(NL-s)+s) + 0.5f;
       Color.rgb += hr*hr * diffuse.rgb;
       Color.rgb += hr*hr * underSkin;
    }

    return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// XyLxvZ
float3 HgOreShader_GetSpecularRate(float3 fresnel0, float3 N, float3 V, float3 L, float atr)
{
    float3 H = normalize(L + V);

    float NH = dot(N, H);
    float NL = dot(N, L);
    float NV = dot(N, V);
    float VH = dot(V, H);

    // }CNt@Zbg̕z֐(Trowbridge-Reitz (GGX) NDF)
    const float PAI = 3.14159265f;
    float atr2 = atr*atr;
    float x = NH * NH * (atr2 - 1.0f) + 1.0f;
    float D = max(atr2 / (PAI * x * x), 0.0f);

    // 􉽌(Cook-Torrance̎@)
    float t = 2.0f * NH / VH;
    float G = min(1.0f, min(t * NV, t * NL));

    // tl˗(KEVAߎ)
    float3 F = lerp( fresnel0, float3(1.0f, 1.0f, 1.0f), exp(-5.0f * VH) );

    return max(F*D*G/(4.0f*NV), 0.0);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// ٕˌ̌
float HgOreShader_GetSpecularAnisotropicRate(float3 N, float3 L, float3 dir, float f)
{
    float3 vecTan = normalize( cross(L, N) );
    vecTan = cross(vecTan, N);
    float d = abs( dot(vecTan, dir) );
    float x = d / max(sin(radians(f)), 0.0001f);
    return exp(-x*x);
}

////////////////////////////////////////////////////////////////////////////////////////////////
// FZx
float4 HgOreShader_GetColorDensity(float4 color, float lightNormal, float density)
{
    float hr = 0.5f * lightNormal + 0.5f;
    float e = lerp( max(density+1.0f, 1.0f), 1.0f, smoothstep(0.0f, 0.8f, hr*hr) );
    float a = 1.0f / e;
    float b = 1.0f - smoothstep(3.0f, 6.0f, e);
    float3 resColor = lerp(color.rgb*a, color.rgb*b, pow(color.rgb, e));
    color = float4(saturate(resColor), color.a);

    return color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// eFZx
float4 HgOreShader_GetShadowDensity(float4 shadowColor, float density)
{
    float e = max(density+1.0f, 1.0f);
    float a = 1.0f / e;
    float b = 1.0f - smoothstep(3.0f, 6.0f, e);
    float3 resColor = lerp(shadowColor.rgb*a, shadowColor.rgb*b, pow(shadowColor.rgb, e));
    shadowColor = float4(saturate(resColor), shadowColor.a);

    return shadowColor;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// MMDWVhE}bv̎Օ߂
#ifndef MIKUMIKUMOVING

float HgOreShader_GetMMDSelfShadowRate(float zplot, float2 Tex, sampler2D Samp, uniform bool useSoftShadow, float distBlurPower)
{
    float comp = 1.0f;

    // MMDW̕@
    if(parthf){
        comp = 1.0f - saturate( max(zplot - tex2D(Samp, Tex).r, 0.0f) * 8000.0f * Tex.y - 0.3f);
    }else{
        comp = 1.0f - saturate( max(zplot - tex2D(Samp, Tex).r, 0.0f) * 1500.0f - 0.3f);
    }

    if(useSoftShadow){
    // \tgVhE
        //const float distBlurPower = 1.0f;
        float2 smpStep = float2(1.0f/2048.0f, 1.0f/2048.0f)*distBlurPower;
        float2 smpStep1 = smpStep * 0.70710678f;
        float2 smpStep2 = smpStep * 1.41421356f;
        float2 SampStep[13] = { float2(0.0f, 0.0f),
                                float2(-smpStep1.x, 0.0f),
                                float2( smpStep1.x, 0.0f),
                                float2( 0.0f,-smpStep1.y),
                                float2( 0.0f, smpStep1.y),
                                float2(-smpStep.x,-smpStep.y),
                                float2( smpStep.x, smpStep.y),
                                float2(-smpStep.x, smpStep.y),
                                float2( smpStep.x,-smpStep.y),
                                float2(-smpStep2.x, 0.0f),
                                float2( smpStep2.x, 0.0f),
                                float2( 0.0f,-smpStep2.y),
                                float2( 0.0f, smpStep2.y) };

        // ӂ𕽋ω
        comp += comp;
        float weight = 2.0f;
        if(parthf){
            [unroll]
            for(int i=1; i<13; i++){
                float2 texCoord = Tex + SampStep[i];
                comp += 1.0f - saturate( max(zplot - tex2D(Samp, texCoord).r, 0.0f) * 8000.0f * Tex.y - 0.3f);
                weight += 1.0f;
            }
        }else{
            [unroll]
            for(int i=1; i<13; i++){
                float2 texCoord = Tex + SampStep[i];
                comp += 1.0f - saturate( max(zplot - tex2D(Samp, texCoord).r, 0.0f) * 1500.0f - 0.3f);
                weight += 1.0f;
            }
        }
        comp /= weight;  // ω
    }

    return comp;
}

#endif

////////////////////////////////////////////////////////////////////////////////////////////////
// tlsߗ(KEVAߎ)
float4 HgOreShader_FresnelTrans(float4 color, float3 N, float3 V)
{
    float F = min(lerp( color.a, 1.3f, exp(-4.0f * dot(N, V)) ), 1.0f)*step(0.01f, color.a);
    return float4(color.rgb, F);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// JZ]ɒǏ]r[]s̍쐬(LookPos:_ʒu, LookDir:_)
float3x3 HgOreShader_ViewMatrixZRot(float3 LookPos, float3 LookDir)
{
   // zxNg
   float3 viewZ = LookDir;

   // xxNg
   float3 viewX = cross( float3(0.0f,1.0f,0.0f), LookDir ); 

   // xxNg̐K(LookDir^܂͐^̕łْ͓lƂȂ)
   if( !any(viewX) ) viewX = float3(1.0f, 0.0f, 0.0f);
   viewX = normalize(viewX);

   // yxNg
   float3 viewY = cross( viewZ, viewX );  // ɐȂ̂łŐK

   // r[Wϊ̉]s
   return float3x3( viewX.x, viewY.x, viewZ.x,
                    viewX.y, viewY.y, viewZ.y,
                    viewX.z, viewY.z, viewZ.z );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// RgXg̕ύX
float3 HgOreShader_ChangeContrast(float3 color, float power)
{
    // RGBYCbCrւ̕ϊ
    float Y  =  0.298912f * color.r + 0.586611f * color.g + 0.114478f * color.b;
    float Cb = -0.168736f * color.r - 0.331264f * color.g + 0.5f      * color.b;
    float Cr =  0.5f      * color.r - 0.418688f * color.g - 0.081312f * color.b;

    // PxύX(RgXg␳)
    float p = clamp(power, -1.0, 0.9999f);
    if(p < 0.0f){
       Y = 2.0f * Y - 1.0f;
       Y = (1.0f + p) * Y;
       Y = saturate((Y + 1.0f) * 0.5f);
    }
    else if(p > 0.0f){
       Y = 2.0f * Y - 1.0f;
       Y = Y / (1.0f - p);
       Y = saturate((Y + 1.0f) * 0.5f);
    }

    // YCbCrRGBւ̕ϊ
    float R = Y - 0.000982f * Cb + 1.401845f * Cr;
    float G = Y - 0.345117f * Cb - 0.714291f * Cr;
    float B = Y + 1.771019f * Cb - 0.000154f * Cr;
    return float3( R, G, B );
}

#endif

