////////////////////////////////////////////////////////////////////////////////////////////////
//
//  HgOreShader v0.0.1  ₷d̃AnVF[_ł
//  (HgOreShader_Main.fxh : ̃VF[_̃CvO)
//  쐬: jP
//
////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef MIKUMIKUSHADING_TEST

#include "MMShader/Common/MMD_Parameters.fxh"
#include "MMShader/HgOreShader/HgOreShader_SubFunc.fxh"

#if M0034_SELFSHADOWMODE == 3
#include "MMShader/Common/HgShadow_ObjHeader.fxh"
#endif

#if M0034_SELFSHADOWMODE == 4
#include "MMShader/Common/ExcellentShadow_ObjHeader.fxh"
#endif

#if M0034_SELFSHADOWMODE == 5
#include "MMShader/Common/LocalShadow_Header1.fxh"
#endif

#if M0034_SELFSHADOWMODE == 6
#include "MMShader/Common/LocalShadow_Header2.fxh"
#endif

#else

#include "MMD_Parameters.fxh"
#include "HgOreShader_SubFunc.fxh"

#if M0034_SELFSHADOWMODE == 3
#include "HgShadow_ObjHeader.fxh"
#endif

#if M0034_SELFSHADOWMODE == 4
#include "ExcellentShadow_ObjHeader.fxh"
#endif

#if M0034_SELFSHADOWMODE == 5
#include "LocalShadow_Header1.fxh"
#endif

#if M0034_SELFSHADOWMODE == 6
#include "LocalShadow_Header2.fxh"
#endif

#endif

////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef M0034_USE_NORMALMAP1
#ifdef M0034_EXIST_NORMALMAP1
   #define M0034_VALID_NORMALMAP1
#endif
#endif

#ifdef M0034_USE_NORMALMAP2
#ifdef M0034_EXIST_NORMALMAP2
   #define M0034_VALID_NORMALMAP2
#endif
#endif

#ifdef M0034_USE_SPECULARMAP
#ifdef M0034_EXIST_SPECULARMAP
   #define M0034_VALID_SPECULARMAP
#endif
#endif


#ifndef M0034_VALID_NORMALMAP1
#ifndef M0034_VALID_NORMALMAP2
#ifndef M0034_USE_INSTANTNORMALMAP
    #define M0034_NOTING_NORMALMAP
#endif
#endif
#endif


// @}bv1
#ifdef M0034_VALID_NORMALMAP1
texture2D M0034_NormalMap1 <
    string ResourceName = M0034_NORMALMAP_FILE1;
    int MipLevels = 0;
>;
sampler M0034_NormalMapSamp1 = sampler_state {
    texture = <M0034_NormalMap1>;
    MINFILTER = ANISOTROPIC;
    MAGFILTER = ANISOTROPIC;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};
#endif

// @}bv2
#ifdef M0034_VALID_NORMALMAP2
texture2D M0034_NormalMap2 <
    string ResourceName = M0034_NORMALMAP_FILE2;
    int MipLevels = 0;
>;
sampler M0034_NormalMapSamp2 = sampler_state {
    texture = <M0034_NormalMap2>;
    MINFILTER = ANISOTROPIC;
    MAGFILTER = ANISOTROPIC;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};
#endif

// XyL}bv
#ifdef M0034_VALID_SPECULARMAP
texture2D M0034_SpecularMap <
    string ResourceName = M0034_SPECULARMAP_FILE;
    int MipLevels = 0;
>;
sampler M0034_SpecularMapSamp = sampler_state {
    texture = <M0034_SpecularMap>;
    MINFILTER = ANISOTROPIC;
    MAGFILTER = ANISOTROPIC;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};
#endif


////////////////////////////////////////////////////////////////////////////////////////////////
// Ȗ@}bv쐬
#ifdef M0034_USE_INSTANTNORMALMAP

texture M0034_InstantNormalMapTexture : RENDERCOLORTARGET <
    int Width = M0034_INSTANTNORMALMAP_TEXSIZE;
    int Height = M0034_INSTANTNORMALMAP_TEXSIZE;
    int MipLevels = 0;
    string Format = "D3DFMT_A8R8G8B8" ;
>;
sampler M0034_InstantNormalMapSampler = sampler_state {
    texture = <M0034_InstantNormalMapTexture>;
    MINFILTER = ANISOTROPIC;
    MAGFILTER = ANISOTROPIC;
    MIPFILTER = LINEAR;
    MAXANISOTROPY = 16;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};

texture2D M0034_InstantNormalMapDepthBuffer : RENDERDEPTHSTENCILTARGET <
    int Width = M0034_INSTANTNORMALMAP_TEXSIZE;
    int Height = M0034_INSTANTNORMALMAP_TEXSIZE;
    string Format = "D3DFMT_D24S8";
>;

// _O^[Qbg̃NAl
float4 M0034_InstantNormalMapClearColor = {0,0,0,0};
float M0034_InstantNormalMapClearDepth  = 1.0;

struct M0034_VS_OUTPUT_INSTANTNORMALMAP {
    float4 Pos  : POSITION;
    float2 Tex  : TEXCOORD0;
};
// Ȗ@}bv`̒_VF[_
M0034_VS_OUTPUT_INSTANTNORMALMAP M0034_VS_InstantNormalMapCreater( float4 Pos : POSITION, float2 Tex : TEXCOORD0 )
{
    M0034_VS_OUTPUT_INSTANTNORMALMAP Out;
    Out.Pos = Pos;
    Out.Tex = Tex + (float2(0.5f, 0.5f) / M0034_INSTANTNORMALMAP_TEXSIZE);
    return Out;
}

// Ȗ@}bv`̃sNZVF[_
float4  M0034_PS_InstantNormalMapCreater(float2 Tex: TEXCOORD0) : COLOR0
{
    float4 Color = float4(0.5f, 0.5f, 1.0f, 1.0f);
    if(use_texture){
        float2 TexStep = float2(1.0f, 1.0f) * M0034_INSTANTNORMALMAP_SAMPSTEP / M0034_INSTANTNORMALMAP_TEXSIZE;
        float4 TexColor0 = tex2D(ObjTexSampler, Tex);
        float4 TexColorL = tex2D(ObjTexSampler, Tex+float2( TexStep.x, 0.0f));
        float4 TexColorR = tex2D(ObjTexSampler, Tex+float2(-TexStep.x, 0.0f));
        float4 TexColorU = tex2D(ObjTexSampler, Tex+float2(0.0f,-TexStep.y));
        float4 TexColorD = tex2D(ObjTexSampler, Tex+float2(0.0f, TexStep.y));
        float v0 = 0.298912f * TexColor0.r + 0.586611f * TexColor0.g + 0.114478f * TexColor0.b;
        float vL = 0.298912f * TexColorL.r + 0.586611f * TexColorL.g + 0.114478f * TexColorL.b;
        float vR = 0.298912f * TexColorR.r + 0.586611f * TexColorR.g + 0.114478f * TexColorR.b;
        float vU = 0.298912f * TexColorU.r + 0.586611f * TexColorU.g + 0.114478f * TexColorU.b;
        float vD = 0.298912f * TexColorD.r + 0.586611f * TexColorD.g + 0.114478f * TexColorD.b;
        Color.rgb = normalize( float3(vL-vR, vD-vU, 1.0f) );
        Color.rgb = (Color.rgb + 1.0f) * 0.5f;
        Color.a = v0;
    }
    return Color;
}

#endif


#ifndef M0034_OUTPUT_MIRROR_OBJECT
///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`

struct M0034_VS_INPUT {
    float4 Pos    : POSITION;     // f_W
    float3 Normal : NORMAL;       // @
    float2 Tex    : TEXCOORD0;    // UVW
};

struct M0034_VS_OUTPUT {
    float4 Pos       : POSITION;     // ˉeϊW
    float4 ZCalcTex  : TEXCOORD0;    // Zl
    float2 Tex       : TEXCOORD1;    // eNX`
    float3 Normal    : TEXCOORD2;    // @
    float3 Eye       : TEXCOORD3;    // JƂ̑Έʒu
    float4 PPos      : TEXCOORD4;    // HgShadow,ExcellentShadowpˉeW
    float4 ZCalcTex2 : TEXCOORD5;    // LocalShadowpZl
};


// _VF[_
M0034_VS_OUTPUT M0034_VS_Object(M0034_VS_INPUT IN)
{
    M0034_VS_OUTPUT Out = (M0034_VS_OUTPUT)0;

    // J_̃[hr[ˉeϊ
    Out.Pos = mul( IN.Pos, WorldViewProjMatrix );
    Out.PPos = Out.Pos;

    // _@
    Out.Normal = normalize( mul( IN.Normal, (float3x3)WorldMatrix ) );

    // @琳ʕɕ␳
    #ifdef M0034_UPDATE_FACENORMAL
    float3 WPos = mul( IN.Pos, WorldMatrix ).xyz;
    Out.Normal = HgOreShader_GetFlontFaceNormal(WPos, Out.Normal, M0034_FACENORMAL_VDIR, M0034_FACENORMAL_RATE_H, M0034_FACENORMAL_RATE_V);
    #endif

    // JƂ̑Έʒu
    Out.Eye = CameraPosition - mul( IN.Pos, WorldMatrix ).xyz;

    // Cg_ɂ郏[hr[ˉeϊ
    Out.ZCalcTex = mul( IN.Pos, LightWorldViewProjMatrix );

    #if (M0034_SELFSHADOWMODE == 5 || M0034_SELFSHADOWMODE == 6)
    // LocalCg_ɂ郏[hr[ˉeϊ
    Out.ZCalcTex2 = mul( IN.Pos, LocalShadow_LightWorldViewProjMatrix );
    #endif

    // eNX`W
    Out.Tex = IN.Tex;

    // ExcellentShadow̒iɂ邿h~
    #if (M0034_SELFSHADOWMODE == 4)
    Out.Pos.z -= max(0, (int)((ExShadow_CameraDistance1 - 6000) * 0.04));
    #endif

    return Out;
}



////////////////////////////////////////////////////////////////////////////////////////////////

// sNZVF[_
float4 M0034_PS_Object(M0034_VS_OUTPUT IN, uniform bool UseSelfShadow) : COLOR
{
    // LocalShadowgp̃CgC
    #if (M0034_SELFSHADOWMODE == 5 || M0034_SELFSHADOWMODE == 6)
        LightDirection = LocalShadow_GetLightDirection(LightDirection);
    #endif

    // f@
    float3 Normal0 = normalize(IN.Normal);

    // ˌEXtBA}bv̖@
    float3 NormalS = Normal0;

    // ʕ
    float3 ViewDir = normalize(IN.Eye);

    // ̃sNZ̖@ݒ
    #ifdef M0034_NOTING_NORMALMAP
    // @}bv
        float3 Normal = Normal0;
    #else
    // @}bvL
        // ڋԂWorldԂւ̕ϊs
        float3x3 TangentMatrix = HgOreShader_GetTangentMatrix(Normal0, IN.Eye, IN.Tex);
        // WorldԂڋԂւ̕ϊs
        float3x3 invTangentMatrix = transpose(TangentMatrix);

        // @}bv1
        #ifdef M0034_VALID_NORMALMAP1
            float2 NormalMapUV1 = IN.Tex / max((M0034_NORMALMAP_SCALE1), 0.01f) + (M0034_NORMALMAP_SHIFT1);
            #ifdef M0034_NORMALMAP_PARALLAX1
                float Height1 = tex2D(M0034_NormalMapSamp1, NormalMapUV1).a;
                NormalMapUV1 -= mul(ViewDir, invTangentMatrix).xy * Height1 * 0.01f * (M0034_NORMALMAP_PARALLAX_PARAM1) * (M0034_NORMALMAP_HEIGHT1);
            #endif
            float3 Normal1 = 2.0f * tex2D(M0034_NormalMapSamp1, NormalMapUV1).xyz - 1.0f;
            Normal1.xy *= (M0034_NORMALMAP_HEIGHT1);
            Normal1 = normalize(Normal1);
            Normal1 /= max(Normal1.z, 0.001f);
        #else
            float3 Normal1 = float3(0,0,1);
        #endif

        // @}bv2
        #ifdef M0034_VALID_NORMALMAP2
            float2 NormalMapUV2 = IN.Tex / max((M0034_NORMALMAP_SCALE2), 0.01f) + (M0034_NORMALMAP_SHIFT2);
            #ifdef M0034_NORMALMAP_PARALLAX2
                float Height2 = tex2D(M0034_NormalMapSamp2, NormalMapUV2).a;
                NormalMapUV2 -= mul(ViewDir, invTangentMatrix).xy * Height2 * 0.01f * (M0034_NORMALMAP_PARALLAX_PARAM2) * (M0034_NORMALMAP_HEIGHT2);
            #endif
            float3 Normal2 = 2.0f * tex2D(M0034_NormalMapSamp2, NormalMapUV2).xyz - 1.0f;
            Normal2.xy *= (M0034_NORMALMAP_HEIGHT2);
            Normal2 = normalize(Normal2);
            Normal2 /= max(Normal2.z, 0.001f);
        #else
            float3 Normal2 = float3(0,0,1);
        #endif

        // Ȗ@}bv
        #ifdef M0034_USE_INSTANTNORMALMAP
            #ifdef M0034_INSTANTNORMALMAP_PARALLAX
                float Height3 = tex2D(M0034_InstantNormalMapSampler, IN.Tex).a;
                float2 TexCoord3 = IN.Tex - mul(ViewDir, invTangentMatrix).xy * Height3 * 0.01f * (M0034_INSTANTNORMALMAP_PARALLAX_PARAM) * (M0034_INSTANTNORMALMAP_HEIGHT);
                float3 Normal3 = 2.0f * tex2D(M0034_InstantNormalMapSampler, TexCoord3).xyz - 1.0f;
            #else
                float3 Normal3 = 2.0f * tex2D(M0034_InstantNormalMapSampler, IN.Tex).xyz - 1.0f;
            #endif
            Normal3.xy *= (M0034_INSTANTNORMALMAP_HEIGHT);
            Normal3 = normalize(Normal3);
            Normal3 /= max(Normal3.z, 0.001f);
        #else
            float3 Normal3 = float3(0,0,1);
        #endif

        // gp@}bv̍
        float3 Normal = normalize(float3(Normal1.xy + Normal2.xy + Normal3.xy, 1.0));

        // ڋԂWorldԂւ̕ϊ
        Normal = mul(Normal, TangentMatrix);

        // ˌEXtBA}bv̖@
        NormalS = normalize(lerp(Normal0, Normal, M0034_SSNORMAL_RATE));
    #endif

    // CCgݒ
    float3 Lt0Dir = normalize(-LightDirection); // 
    float3 Lt0Color = LightSpecular * (M0034_LIGHT0_COLOR);  // CgF
    float Lt0Foctor = M0034_LIGHT0_FOCTOR;          // ex

    // XyL}bvݒ
    float3 specMapPower = float3(1.0f, 1.0f, 1.0f);
    float specMapAnisoRate0 = 1.0f;
    #ifdef M0034_VALID_SPECULARMAP
        float3 SpecularMapColor =  tex2D(M0034_SpecularMapSamp, IN.Tex).xyz;
        #if( M0034_SPECULARMAP_RGBTYPE == 0 )
            specMapPower = SpecularMapColor * (M0034_SPECULARMAP_POWER_SCALE);
        #endif
        #if( M0034_SPECULARMAP_RGBTYPE == 1 )
            specMapPower = float3(SpecularMapColor.r, SpecularMapColor.r, SpecularMapColor.r) * (M0034_SPECULARMAP_POWER_SCALE);

            float2 spvac = float2(SpecularMapColor.b * 2.0f - 1.0f, SpecularMapColor.g * 2.0f - 1.0f);
            float3 specMapDir = float3(normalize(spvac), 0.0f);
            #ifdef M0034_NOTING_NORMALMAP
                float3x3 TangentMatrix = HgOreShader_GetTangentMatrix(Normal0, IN.Eye, IN.Tex);
            #endif
            specMapDir = mul(specMapDir, TangentMatrix);
            specMapAnisoRate0 = HgOreShader_GetSpecularAnisotropicRate(Normal0, Lt0Dir, specMapDir, M0034_SPECULARMAP_ANISOTROPY_SCALE);
        #endif
    #endif

    // ⏕Cgݒ
    #ifdef M0034_USE_LIGHT1
        float3 Lt1Dir = ViewDir;                       // 
        float  Lt1Foctor = M0034_LIGHT1_FOCTOR;              // ex
        float  Lt1SpecFoctor = M0034_LIGHT1_SPECULAR_FOCTOR; // XyLex
        #ifdef M0034_USE_LIGHT1_COLOR
            float3 Lt1Color = M0034_LIGHT1_COLOR * 0.6f; // CgF
        #else
            float3 Lt1Color = Lt0Color;  // CgF
        #endif
    #endif
    #ifdef M0034_USE_LIGHT2
        float3 Lt2Dir = float3(Lt0Dir.x, Lt0Dir.y, -Lt0Dir.z); // 
        float  Lt2Foctor = M0034_LIGHT2_FOCTOR;                      // ex
        float  Lt2SpecFoctor = M0034_LIGHT2_SPECULAR_FOCTOR;         // XyLex
        #ifdef M0034_USE_LIGHT2_COLOR
            float3 Lt2Color = M0034_LIGHT2_COLOR * 0.6f; // CgF
        #else
            float3 Lt2Color = Lt0Color;  // CgF
        #endif
        #ifdef M0034_VALID_SPECULARMAP
        #if( M0034_SPECULARMAP_RGBTYPE == 1 )
            Lt2SpecFoctor *= HgOreShader_GetSpecularAnisotropicRate(Normal0, Lt2Dir, specMapDir, M0034_SPECULARMAP_ANISOTROPY_SCALE);
        #endif
        #endif
    #endif

    // eF̉ex
    float ambientFoctor = M0034_AMBIENT_FOCTOR;
    float diffuseFoctor = M0034_DIFFUSE_FOCTOR;
    float specularFoctor = M0034_SPECULAR_FOCTOR;

    // \ʂ̂x
    float Roughness = (M0034_ROUGHNESS);

    // ˎ̃tl˗
    float3 Fresnel0 = M0034_FRESNEL0;

    // eF̔Z
    float ShadowDensity = M0034_SHADOW_DENSITY;

    // ArGg̃x[XJ[
    float3 AmbientColor = MaterialEmmisive  * LightAmbient;
    float3 AmbientColorAcs = MaterialAmbient * LightAmbient + MaterialEmmisive;
    float3 ambient = use_toon ? AmbientColor*MaterialToon : AmbientColorAcs;
    ambient *= (M0034_LIGHT0_COLOR);

    // fBt[Y,XyL̃x[XJ[(Cg͌ōl)
    float4 diffuse = MaterialDiffuse;
    #ifndef M0034_USE_CUSTUM_SPECULARCOLOR
        float3 specular = MaterialSpecular;
        float3 specPower = float3(SpecularPower, SpecularPower, SpecularPower);
    #else
        float3 specular = MaterialDiffuse.rgb;
        float3 specPower = float3(M0034_CUSTUM_SPECULAR_POWER, M0034_CUSTUM_SPECULAR_POWER, M0034_CUSTUM_SPECULAR_POWER);
    #endif

    #ifdef M0034_VALID_SPECULARMAP
        #if( M0034_SPECULARMAP_CALCTYPE == 0 )
            specPower *= specMapPower;
        #else
            specPower += specMapPower;
        #endif
    #endif

    // eNX`Kp
    if ( use_texture ) {
        float4 TexColor = tex2D( ObjTexSampler, IN.Tex );
        #ifndef M0034_FLG_EXCEPTION
        // eNX`ގ[t
        TexColor.rgb = lerp(1, TexColor * TextureMulValue + TextureAddValue, TextureMulValue.a + TextureAddValue.a).rgb;
        #endif
        diffuse *= TexColor;
        ambient *= TexColor.rgb;
    }

    // ArGgF
    float4 Color = float4(ambient * ambientFoctor, diffuse.a);

    // e̐F
    float4 ShadowColor = Color;

    // ȕւȕ\牺U
    #ifdef M0034_USE_UNDERSKIN_DIFFUSE
        float3 underSkin = M0034_UNDERSKIN_COLOR;
    #else
        float3 underSkin = float3(0.0f, 0.0f, 0.0f);
    #endif

    // fBt[YFǉ
    float4 duffColor0 = diffuse * float4(Lt0Color, 1.0f);
    Color.rgb += HgOreShader_GetDiffuseColor(duffColor0, underSkin, Normal, Lt0Dir) * diffuseFoctor * Lt0Foctor;
    ShadowColor.rgb += HgOreShader_GetShadowDiffuseColor(duffColor0, underSkin, Normal, Lt0Dir) * diffuseFoctor * Lt0Foctor;

    float3 duffColor = float3(0.0f, 0.0f, 0.0f);
    #ifdef M0034_USE_LIGHT1
        duffColor0 = diffuse * float4(Lt1Color, 1.0f);
        duffColor += HgOreShader_GetDiffuseColor(duffColor0, underSkin, Normal, Lt1Dir) * diffuseFoctor * Lt1Foctor;
    #endif
    #ifdef M0034_USE_LIGHT2
        duffColor0 = diffuse * float4(Lt2Color, 1.0f);
        duffColor += HgOreShader_GetDiffuseColor(duffColor0, underSkin, Normal, Lt2Dir) * diffuseFoctor * Lt2Foctor;
    #endif

    Color.rgb += duffColor;
    ShadowColor.rgb += duffColor;
    Color = saturate( Color );
    ShadowColor = saturate( ShadowColor );

    // XyLFǉ
    float3 specColor = specular * specPower * specularFoctor;
    float3 specularRate = HgOreShader_GetSpecularRate(Fresnel0, NormalS, ViewDir, Lt0Dir, Roughness);
    float3 specColor0 = specColor * specularRate * Lt0Color * Lt0Foctor * specMapAnisoRate0;

    #ifdef M0034_USE_LIGHT1
        specularRate = HgOreShader_GetSpecularRate(Fresnel0, NormalS, ViewDir, Lt1Dir, Roughness);
        specColor0 += specColor * specularRate * Lt1Color * Lt1Foctor * Lt1SpecFoctor;
    #endif
    #ifdef M0034_USE_LIGHT2
        specularRate = HgOreShader_GetSpecularRate(Fresnel0, NormalS, ViewDir, Lt2Dir, Roughness);
        specColor0 += specColor * specularRate * Lt2Color * Lt2Foctor * Lt2SpecFoctor;
    #endif

    Color.rgb += specColor0;
    ShadowColor.rgb += specColor0 * 0.6f;

    // Cgǉ
    #ifdef M0034_USE_RIMLIGHT
        float Rim = 1.0f - max( 0.0f, dot(Normal0, ViewDir) );
        Rim = pow(Rim, 1.0f/max(M0034_RIMLIGHT_SCALE, 0.01f)) * (M0034_RIMLIGHT_POWER);
        Color.rgb += (M0034_RIMLIGHT_COLOR) * Rim;
        ShadowColor.rgb += (M0034_RIMLIGHT_COLOR) * Rim;
    #endif

    // XtBA}bvKp
    #ifdef M0034_DRAW_SPHEREMAP
    if ( use_spheremap ) {
        #ifndef M0034_SPHEREMAP_ZROT_COMPLIANCE
            float2 NormalWV = mul( NormalS, (float3x3)ViewMatrix ).xy;
        #else
            float3x3 ViewMatrixZRot = HgOreShader_ViewMatrixZRot(CameraPosition, CameraDirection);
            float2 NormalWV = mul( NormalS, ViewMatrixZRot ).xy;
        #endif
        float2 SpTex = float2( NormalWV.x * 0.5f + 0.5f, NormalWV.y * -0.5f + 0.5f );
        float4 TexColor = tex2D(ObjSphareSampler, SpTex);
        #ifndef M0034_FLG_EXCEPTION
        // XtBAeNX`ގ[t
        TexColor.rgb = lerp(spadd?0:1, TexColor * SphereMulValue + SphereAddValue, SphereMulValue.a + SphereAddValue.a).rgb;
        #endif
        if(spadd) {
            Color.rgb += TexColor.rgb;
            ShadowColor.rgb += TexColor.rgb;
        } else {
            Color.rgb *= TexColor.rgb;
            ShadowColor.rgb *= TexColor.rgb;
        }
        Color.a *= TexColor.a;
        ShadowColor.a *= TexColor.a;
    }
    #endif

    // 臒lȉ͕`悵Ȃ
    clip(Color.a - max(M0034_ALPHA_CLIP, 0.004f));

    // eZx
    float LightNormal = dot(Normal, Lt0Dir);
    Color = HgOreShader_GetColorDensity(Color, LightNormal, ShadowDensity);
    ShadowColor = HgOreShader_GetShadowDensity(ShadowColor, ShadowDensity);

    // ZtVhE`
    #if (M0034_SELFSHADOWMODE > 0)
    if(UseSelfShadow){
        float comp = 1.0;

        // LocalShadowɂՕ
        #if (M0034_SELFSHADOWMODE == 5 || M0034_SELFSHADOWMODE == 6)
        if( LocalShadow_Valid ){

            // eNX`Wɕϊ
            IN.ZCalcTex2 /= IN.ZCalcTex2.w;
            float2 TransTexCoord;
            TransTexCoord.x = (1.0f + IN.ZCalcTex2.x)*0.5f;
            TransTexCoord.y = (1.0f - IN.ZCalcTex2.y)*0.5f;

            // LocalVhE}bvɂՕ
            if( !any( saturate(TransTexCoord) - TransTexCoord ) ) {
                comp = LocalShadow_GetSelfShadowRate(TransTexCoord, IN.ZCalcTex2.z);
            }
            comp = min(saturate(LightNormal * 3.0f), comp);

            // eFɔZx
            LocalShadow_COLOR ls_Out = LocalShadow_GetShadowDensity(Color, ShadowColor, use_toon, LightNormal);
            Color = ls_Out.Color;
            ShadowColor = ls_Out.ShadowColor;

        }else
        #endif

        // HgShadowɂՕ
        #if (M0034_SELFSHADOWMODE == 3)
        if( HgShadow_Valid ){

            // e攻
            comp = HgShadow_GetSelfShadowRate(IN.PPos);
            comp = min(saturate(LightNormal * 3.0f), comp);

            // eFɔZx
            HgShadow_COLOR hgs_Color = HgShadow_GetShadowDensity(Color, ShadowColor, use_toon, LightNormal);
            Color = hgs_Color.Color;
            ShadowColor = hgs_Color.ShadowColor;

        }else
        #endif

        // ExcellentShadowɂՕ
        #if (M0034_SELFSHADOWMODE == 4)
        if( Exist_ExcellentShadow ){

            // e攻
            ExShadow_RATE es_Rate = ExShadow_GetSelfShadowRate(IN.PPos);
            es_Rate.SadowMapVal = min(saturate(LightNormal * 3.0f), es_Rate.SadowMapVal);

            // FEeF߂
            ExShadow_COLOR es_Color = ExShadow_GetSelfShadowColor(es_Rate, Color, ShadowColor, use_toon);
            comp = es_Rate.SadowMapVal;
            Color = es_Color.Color;
            ShadowColor = es_Color.ShadowColor;

        }else
        #endif

        // MMDWVhE}bvɂՕ
        {
            // eNX`Wɕϊ
            IN.ZCalcTex /= IN.ZCalcTex.w;
            float2 TransTexCoord;
            TransTexCoord.x = (1.0f + IN.ZCalcTex.x)*0.5f;
            TransTexCoord.y = (1.0f - IN.ZCalcTex.y)*0.5f;

            if( !any( saturate(TransTexCoord) - TransTexCoord ) ) {
                #if (M0034_SELFSHADOWMODE == 2)
                    comp = HgOreShader_GetMMDSelfShadowRate(IN.ZCalcTex.z, TransTexCoord, MMDShadowMapSampler, true, M0034_SOTSHADOWMODE_BLUR);
                #else
                    comp = HgOreShader_GetMMDSelfShadowRate(IN.ZCalcTex.z, TransTexCoord, MMDShadowMapSampler, false, 1.0f);
                #endif
                comp = min(saturate(LightNormal * 3.0f), comp);
            }
        }

        // e̍
        Color = lerp(ShadowColor, Color, comp);
    }
    #endif

    if(UseSelfShadow){
        // 
        if( use_toon ){
           if( transp ) Color.a *= 0.5f;
        }else{
           Color.a *= AcsTrans;
        }
    }

    // K}␳
    #ifdef M0034_USE_CHANGE_GAMMA
        Color.rgb = pow(Color.rgb, M0034_GAMMA_PARAM);
    #endif

    // RgXg␳
    #ifdef M0034_USE_CHANGE_CONTRAST
        Color.rgb = HgOreShader_ChangeContrast(Color.rgb, M0034_CONTRAST_POWER);
    #endif

    // tlsߗ
    #ifdef M0034_USE_FRESNELTRANS
        Color = HgOreShader_FresnelTrans(Color, Normal, ViewDir);
    #endif

    // Ɠx菜
    #ifdef M0034_COLOR_THRESHOLD
        Color.rgb = clamp(Color.rgb, 0.0f, 0.98f);
    #endif

    return Color;
}

//--------------------------------------------------------------------------
// IuWFNg`peNjbN

// ZtVhE`
technique M0034_ObjectTech1  < string MMDPass = "object_ss"; string Subset = M0034_SUBSET_NUMBER;
    #ifdef M0034_USE_INSTANTNORMALMAP
    string Script= 
        "RenderColorTarget0=M0034_InstantNormalMapTexture;"
            "RenderDepthStencilTarget=M0034_InstantNormalMapDepthBuffer;"
                "ClearSetColor=M0034_InstantNormalMapClearColor; Clear=Color;"
                "ClearSetDepth=M0034_InstantNormalMapClearDepth; Clear=Depth;"
            "Pass=CreateInstantNormalMap;"
        "RenderColorTarget0=;"
            "RenderDepthStencilTarget=;"
            "Pass=DrawObject;"
        ;
    #endif
>{
    #ifdef M0034_USE_INSTANTNORMALMAP
    pass CreateInstantNormalMap < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        ZEnable = FALSE;
        VertexShader = compile vs_2_0 M0034_VS_InstantNormalMapCreater();
        PixelShader  = compile ps_2_0 M0034_PS_InstantNormalMapCreater();
    }
    #endif
    pass DrawObject {
        VertexShader = compile vs_3_0 M0034_VS_Object();
        PixelShader  = compile ps_3_0 M0034_PS_Object(true);
    }
}

// ZtVhE`
technique M0034_ObjectTech2  < string MMDPass = "object"; string Subset = M0034_SUBSET_NUMBER;
    #ifdef M0034_USE_INSTANTNORMALMAP
    string Script= 
        "RenderColorTarget0=M0034_InstantNormalMapTexture;"
            "RenderDepthStencilTarget=M0034_InstantNormalMapDepthBuffer;"
                "ClearSetColor=M0034_InstantNormalMapClearColor; Clear=Color;"
                "ClearSetDepth=M0034_InstantNormalMapClearDepth; Clear=Depth;"
            "Pass=CreateInstantNormalMap;"
        "RenderColorTarget0=;"
            "RenderDepthStencilTarget=;"
            "Pass=DrawObject;"
        ;
    #endif
>{
    #ifdef M0034_USE_INSTANTNORMALMAP
    pass CreateInstantNormalMap < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        ZEnable = FALSE;
        VertexShader = compile vs_2_0 M0034_VS_InstantNormalMapCreater();
        PixelShader  = compile ps_2_0 M0034_PS_InstantNormalMapCreater();
    }
    #endif
    pass DrawObject {
        VertexShader = compile vs_3_0 M0034_VS_Object();
        PixelShader  = compile ps_3_0 M0034_PS_Object(false);
    }
}


////////////////////////////////////////////////////////////////////////////////////////////////
// ֊s`
#ifdef M0034_DRAW_EDGE

float4 M0034_VS_Edge(float4 Pos : POSITION) : POSITION 
{
    // J_̃[hr[ˉeϊ
    return mul( Pos, WorldViewProjMatrix );
}

// sNZVF[_
float4 M0034_PS_Edge() : COLOR
{
    // ֊sFœhԂ
    return EdgeColor;
}

// ֊s`peNjbN
technique M0034_EdgeTech < string MMDPass = "edge"; string Subset = M0034_SUBSET_NUMBER; > {

    pass DrawEdge {
        VertexShader = compile vs_2_0 M0034_VS_Edge();
        PixelShader  = compile ps_2_0 M0034_PS_Edge();
    }

}

#else

technique M0034_EdgeTech < string MMDPass = "edge"; string Subset = M0034_SUBSET_NUMBER; > { }

#endif

/*
// ȉ͕W`p邽ߒ`Ȃ
///////////////////////////////////////////////////////////////////////////////////////////////
// eiZtVhEj`

// _VF[_
float4 VS_Shadow(float4 Pos : POSITION) : POSITION
{
    // J_̃[hr[ˉeϊ
    return mul( Pos, WorldViewProjMatrix );
}

// sNZVF[_
float4 PS_Shadow() : COLOR
{
    // nʉeFœhԂ
    return GroundShadowColor;
}

// e`peNjbN
technique ShadowTech < string MMDPass = "shadow"; string Subset = SUBSET_NUM; > {
    pass DrawShadow {
        VertexShader = compile vs_2_0 VS_Shadow();
        PixelShader  = compile ps_2_0 PS_Shadow();
    }
}


///////////////////////////////////////////////////////////////////////////////////////////////
// ZtVhEpZlvbg

struct VS_ZPlotOUTPUT {
    float4 Pos          : POSITION;   // ˉeϊW
    float4 ShadowMapTex : TEXCOORD0;  // Zobt@eNX`
};

// _VF[_
VS_ZPlotOUTPUT VS_ZPlot( float4 Pos : POSITION )
{
    VS_ZPlotOUTPUT Out = (VS_ZPlotOUTPUT)0;

    // Cg̖ڐɂ郏[hr[ˉeϊ
    Out.Pos = mul( Pos, LightWorldViewProjMatrix );

    // eNX`W𒸓_ɍ킹
    Out.ShadowMapTex = Out.Pos;

    return Out;
}

// sNZVF[_
float4 PS_ZPlot( VS_ZPlotOUTPUT IN ) : COLOR
{
    // RFZlL^
    return float4(IN.ShadowMapTex.z/IN.ShadowMapTex.w, 0, 0, 1);
}

// ZlvbgpeNjbN
technique ZplotTech < string MMDPass = "zplot"; string Subset = SUBSET_NUM; > {
    pass ZValuePlot {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 VS_ZPlot();
        PixelShader  = compile ps_2_0 PS_ZPlot();
    }
}
*/

///////////////////////////////////////////////////////////////////////////////////////////////
#else

#ifndef MIKUMIKUSHADING_TEST
    #include "MMShader/HgOreShader/M0034_HgOreShader_Mirror.fxh"
#else
    #include "HgOreShader_Mirror.fxh"
#endif

#endif
